using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for ApplyFuzzyCluster.
	/// </summary>
	public class ApplyFuzzyCluster : System.Windows.Forms.Form
	{
		
		
		int							N;				//number features/components in each feature vector
		int							J;
		int							K;
		int							K1;
		int							R;			//No. feature vectors to be tested
		int							r,m,n,k;								
		int							checkit1,checkit2,checkit3;
		public static double						distance,mind;		     
		public static double[]		            sig2		        = new double[1000]; 
		public static double[]                    DistSum             = new double[250000];
		public static double[,]					raw					= new double[250000,50];		//test data	
		public static double[,]					v					= new double[1000,50];		//center vectors for clusters
		public static double[,]                   Dist				= new double[250000,100];
	    public static double[,]                   FitCluster          = new double[250000,100];
		public static double[,]                   ClassificationBelief= new double[250000,100];

		char						NewLine				= (char)13;
		char						Return				= (char)10;
		
		string						inFile1;			//names of input data files
		string                      inFile2;
		string						outFile;			//name of output data file
		
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.OpenFileDialog openFileDialog2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ApplyFuzzyCluster()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ApplyFuzzyCluster));
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.button6 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.button4 = new System.Windows.Forms.Button();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button1 = new System.Windows.Forms.Button();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.button3 = new System.Windows.Forms.Button();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.groupBox5.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox5
			// 
			this.groupBox5.BackColor = System.Drawing.Color.Transparent;
			this.groupBox5.Controls.Add(this.button6);
			this.groupBox5.Controls.Add(this.button5);
			this.groupBox5.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox5.ForeColor = System.Drawing.Color.SeaShell;
			this.groupBox5.Location = new System.Drawing.Point(32, 376);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(288, 64);
			this.groupBox5.TabIndex = 11;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Step 5: Apply Fuzzy Cluster !";
			// 
			// button6
			// 
			this.button6.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button6.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button6.ForeColor = System.Drawing.Color.SeaShell;
			this.button6.Location = new System.Drawing.Point(160, 24);
			this.button6.Name = "button6";
			this.button6.TabIndex = 1;
			this.button6.Text = "Return";
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// button5
			// 
			this.button5.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button5.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button5.ForeColor = System.Drawing.Color.SeaShell;
			this.button5.Location = new System.Drawing.Point(48, 24);
			this.button5.Name = "button5";
			this.button5.TabIndex = 0;
			this.button5.Text = "Run";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// groupBox4
			// 
			this.groupBox4.BackColor = System.Drawing.Color.Transparent;
			this.groupBox4.Controls.Add(this.button4);
			this.groupBox4.Controls.Add(this.textBox3);
			this.groupBox4.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox4.ForeColor = System.Drawing.Color.SeaShell;
			this.groupBox4.Location = new System.Drawing.Point(32, 292);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(288, 64);
			this.groupBox4.TabIndex = 10;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Step 4: Select Path and Name for Output File !";
			// 
			// button4
			// 
			this.button4.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button4.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button4.ForeColor = System.Drawing.Color.SeaShell;
			this.button4.Location = new System.Drawing.Point(192, 24);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(80, 23);
			this.button4.TabIndex = 1;
			this.button4.Text = "Save As";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// textBox3
			// 
			this.textBox3.Location = new System.Drawing.Point(16, 24);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(160, 22);
			this.textBox3.TabIndex = 0;
			this.textBox3.Text = "";
			// 
			// groupBox2
			// 
			this.groupBox2.BackColor = System.Drawing.Color.Transparent;
			this.groupBox2.Controls.Add(this.button2);
			this.groupBox2.Controls.Add(this.textBox1);
			this.groupBox2.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox2.Location = new System.Drawing.Point(32, 208);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(288, 64);
			this.groupBox2.TabIndex = 9;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Step 3: Input Data File for Classification !";
			this.groupBox2.Enter += new System.EventHandler(this.groupBox2_Enter);
			// 
			// button2
			// 
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button2.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.ForeColor = System.Drawing.Color.Black;
			this.button2.Location = new System.Drawing.Point(192, 24);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(80, 23);
			this.button2.TabIndex = 1;
			this.button2.Text = "Load File";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 24);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(160, 22);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			// 
			// groupBox1
			// 
			this.groupBox1.BackColor = System.Drawing.Color.Transparent;
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox1.Location = new System.Drawing.Point(32, 40);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(288, 64);
			this.groupBox1.TabIndex = 8;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Step 1: Read Instruction Before Processing Data!";
			this.groupBox1.Enter += new System.EventHandler(this.groupBox1_Enter);
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(96, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Instructions";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// textBox4
			// 
			this.textBox4.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.textBox4.Font = new System.Drawing.Font("Times New Roman", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox4.Location = new System.Drawing.Point(352, 48);
			this.textBox4.Multiline = true;
			this.textBox4.Name = "textBox4";
			this.textBox4.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox4.Size = new System.Drawing.Size(408, 392);
			this.textBox4.TabIndex = 12;
			this.textBox4.Text = "";
			// 
			// groupBox3
			// 
			this.groupBox3.BackColor = System.Drawing.Color.Transparent;
			this.groupBox3.Controls.Add(this.button3);
			this.groupBox3.Controls.Add(this.textBox2);
			this.groupBox3.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox3.Location = new System.Drawing.Point(32, 124);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(288, 64);
			this.groupBox3.TabIndex = 13;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Step 2: Input Training Result File !";
			// 
			// button3
			// 
			this.button3.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button3.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button3.ForeColor = System.Drawing.Color.Black;
			this.button3.Location = new System.Drawing.Point(192, 24);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(80, 23);
			this.button3.TabIndex = 1;
			this.button3.Text = "Load File";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(16, 24);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(160, 22);
			this.textBox2.TabIndex = 0;
			this.textBox2.Text = "";
			// 
			// ApplyFuzzyCluster
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(800, 494);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.textBox4);
			this.Controls.Add(this.groupBox5);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "ApplyFuzzyCluster";
			this.Text = "Fuzzy Cluster Classification";
			this.Load += new System.EventHandler(this.ApplyFuzzyCluster_Load);
			this.groupBox5.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void groupBox4_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			
		
			//----------open file-----
			openFileDialog1.Filter = "dta Files (*.dta)|*.dta|All files (*.*)|*.*" ;			

			textBox4.Clear();// clear the contents of textBox4

			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{					
				textBox1.Text = openFileDialog1.FileName;
				inFile1 = openFileDialog1.FileName;				
				
				this.textBox4.AppendText(" Data file has been read successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText("" + textBox1.Text + NewLine + Return+NewLine + Return);
								
				this.textBox4.AppendText(" Please go to step 4! " + NewLine + Return);
				
				checkit2 =1;
			}

			else checkit2 =0;

		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			ApplyFuzzyInstruction dlg = new ApplyFuzzyInstruction();
			dlg.ShowDialog();
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			textBox4.Clear();

			saveFileDialog1.Filter = "fuz Files (*.fuz)|*.fuz|All files (*.*)|*.*" ;
			
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				textBox3.Text = saveFileDialog1.FileName;
				outFile = saveFileDialog1.FileName;	

				this.textBox4.AppendText("The Result of the Fuzzy Cluster Classification for each vector will be saved in the following file : "+ NewLine+Return + NewLine + Return);
				this.textBox4.AppendText(""+ textBox3.Text + NewLine + Return+NewLine + Return);
						
				this.textBox4.AppendText("Please click Run button! "+ NewLine+Return);

				checkit3 =1;

			}

			else checkit3 =0;

			
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			string intText1;

			double minGoodness = 9999.99;
			double sumGoodness = 0;
			double aveGoodness = 0;
			double rawmax,rawmin,rawdiff;

			textBox4.Clear();	
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);	
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);

			

			if((checkit1==1)&&(checkit2 ==1)&&(checkit3 ==1))
			{			
				textBox4.Clear();
							
				this.textBox4.AppendText("The program is running, please wait..." + NewLine + Return);
								
				//define stream buffer and open file for reading 
				FileStream inStream = new FileStream(inFile1,FileMode.Open, 
					FileAccess.Read,FileShare.None);
				//define a variable for reading stream to
				StreamReader reader = new StreamReader(inStream, Encoding.ASCII);

				//start at beginning of input file again
				inStream.Seek(0,SeekOrigin.Begin);
				
				//read single string value: each is on a different file line
				//convert each string into an integer	
				intText1 = reader.ReadLine();
				N = int.Parse(intText1);	
								
				intText1 = reader.ReadLine();
				K1 = int.Parse(intText1);
					

				intText1 = reader.ReadLine();
				J = int.Parse(intText1);
				
				intText1 = reader.ReadLine();
				R = int.Parse(intText1);	
							
				string [] strArray;			
				char[] charArray = new char[] {','};	
			
				
				
				
				
				for (r = 0; r < R; r++)
				{
					intText1 = reader.ReadLine();
					strArray = intText1.Split(charArray);				
					//---------------------begin to read data--------------
					
					n=0;
					for (m = 3;m<strArray.Length-1;m++)
					{									
						//temp[r,m] = Convert.ToDouble(strArray[m]);							
					    raw[r,n] = Convert.ToDouble(strArray[m]);
						//raw[r,n] = temp[r,m];
										
						n++;					
					}								
					
				}  // end of "for r = 0 to r<R" loop
							
				reader.Close();
				inStream.Close();				
			
				for (n=0;n<N;n++)
				{
					rawmax = -999999.9; rawmin = 999999.9;
					for (r=0;r<R;r++)
					{
						if (raw[r,n] > rawmax) rawmax = raw[r,n];
						if (raw[r,n] < rawmin) rawmin = raw[r,n];
					}
					rawdiff = rawmax - rawmin;
					for (r=0;r<R;r++) raw[r,n] = (raw[r,n] - rawmin)/rawdiff;
				}
								
				
				
				
					
					
					for (r = 0; r<R;r++)
					{
							DistSum[r]=0;
					}
					
					for (r=0;r<R;r++)
					{					
						for (k=0;k<K;k++)
						{										
							Dist[r,k] = 0;
						
							distance = 0;	
						
							for (n=0;n<N;n++)
							{
								distance = distance+ Math.Pow((raw[r,n]-v[k,n]),2);
							}
						
							Dist[r,k] = Math.Pow(distance,1); //distance between the vector and cluster center
							
							ClassificationBelief[r,k] = Math.Exp(-Dist[r,k]/(2*sig2[k]));

							//DistSum[r]=DistSum[r] + Dist[r,k]; // distance summation for one vector
						}	// end of "for (k=0;k<K;k++)" loop

					}	//end of "for (r=0;r<R;r++)" loop						
				
				
				//---------------------------save the result to the output file----------------------			
				// get name of selected output file
				
				FileStream outStream = new FileStream(outFile,FileMode.OpenOrCreate);

				// define writer to write stream to output file
				//StreamWriter writer = new StreamWriter(outStream,Encoding.ASCII);
				StreamWriter writer = new StreamWriter(outStream);

				outStream.Seek(0,SeekOrigin.Begin);				
				
				//writer.Write(" " + "Vector No." + " " + "Cluster No." + "    " + "Fit to Cluster 1"+ "    " + "Fit to Cluster 2" + NewLine + Return);
			
				//writer.Write("---------------------------------------------------------------" + NewLine + Return);

				for (k=0;k<FuzzyFunctions.K;k++)
				{
					for(r=0;r<R;r++)
					{
						//cluster[k,r]=0;
						FitCluster[r,k]=0;
						//total[k]=0;			   
					}	     
				}
	    
				int kindex = 0;

				for (r=0;r<R;r++)
				{   
					writer.Write("" + Convert.ToString(r+1));
								
					mind=9999.99;

					for (k=0;k<K;k++)
					{
						if (Dist[r,k] < mind)
						{
							mind=Dist[r,k];				//to get the max.probability for each vector
							kindex=k;			        //get the number of cluster k with biggest probability
						}
						
					}					

					writer.Write("," + Convert.ToString(kindex+1));	
					
					FitCluster[r,kindex] = 1-Dist[r,kindex]/DistSum[r];
												
					if (FitCluster[r,kindex]< minGoodness)

					{
						minGoodness = FitCluster[r,kindex];
					}
					
					sumGoodness = sumGoodness + FitCluster[r,kindex];
					
					//writer.Write("," + Convert.ToString(String.Format("{0:0.000}" , (FitCluster[r,kindex])))+ "   ");

					
					for (k=0;k<K;k++)
					{
						writer.Write("," + Convert.ToString(String.Format("{0:0.000}", (ClassificationBelief[r,k]))));
						
					}				
					writer.Write("" + NewLine + Return);
					
					
					//total[kindex]++;		//total numbers of feature vectors in cluster k

					}			

				aveGoodness = sumGoodness/R;

				textBox4.Clear();
				this.textBox4.AppendText(" The classification is done successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText(" Please go to " + textBox3.Text + " to check out the classification results" +NewLine + Return);
				this.textBox4.AppendText(" ----------------------------------------------------------"+NewLine + Return);
				//this.textBox4.AppendText(" Fuzzy Clustering Classification Overall-Measures: " + NewLine + Return);			
							
				//this.textBox4.AppendText(" Minimum Fit to Class : " + Convert.ToString(String.Format("{0:0.000}" , minGoodness)) + NewLine + Return);
				//this.textBox4.AppendText(" Average Fit to Class : " + Convert.ToString(String.Format("{0:0.000}" , aveGoodness)) + NewLine + Return + NewLine + Return);

				this.textBox4.AppendText("The classification result is being written to the file, please wait..." + NewLine + Return);
		
				//---------------End PNN Calculation Function---------------------      
				//*****************************************************************/
				
				writer.Flush();  
			

				// close output stream
				writer.Close();
				outStream.Close();	
		
				ApplyFuzzyResult dlg = new ApplyFuzzyResult();
				dlg.ShowDialog();

			}

			else
			{
				MessageBox.Show(" Please input valid files before running !" );
			
			}
		
			
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			string intText;
		
			openFileDialog2.Filter = "cen Files (*.cen)|*.cen|All files (*.*)|*.*" ;
			
			textBox4.Clear();

			if(openFileDialog2.ShowDialog() == DialogResult.OK)
			{					
				textBox2.Text = openFileDialog2.FileName;
				inFile2 = openFileDialog2.FileName;
				//define stream buffer and open file for reading 
				FileStream inStream = new FileStream(inFile2,FileMode.Open, 
					FileAccess.Read,FileShare.None);
				//define a variable for reading stream to
				StreamReader reader = new StreamReader(inStream, Encoding.ASCII);

				//start at beginning of input file again
				inStream.Seek(0,SeekOrigin.Begin);
				
				//read single string value: each is on a different file line
				//convert each string into an integer				
				
				intText = reader.ReadLine();
				N = int.Parse(intText);	
								
				intText = reader.ReadLine();
				K = int.Parse(intText);
								
				string [] strArray;			
				char[] charArray = new char[] {' '};	
			
				
				for (k = 0; k < K; k++)
				{
					intText = reader.ReadLine();
					strArray = intText.Split(charArray);
					//-----------demonstrate the input data----------------
					//this.textBox4.AppendText(intText2+ NewLine + Return);	
				
					//---------------------begin to read data--------------
					
					n=0;

					for (m = 0;m<strArray.Length-1;m++)
					{									
						v[k,n] = Convert.ToDouble(strArray[m]);							
					   										
						n++;					
					}	//end of "for (m = 0;m<strArray.Length-1;m++)" loop							
					
				}  // end of "for (k = 0; k < K; k++)" loop

				
				for (k = 0; k < K; k++)
				{
				
					intText = reader.ReadLine();
					sig2[k] = double.Parse(intText);
					
				
				}// end of "for (k = 0; k < K; k++)" loop
				
				this.textBox4.AppendText(" Training result file has been read successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText("" + textBox2.Text + NewLine + Return+NewLine + Return);
				
				this.textBox4.AppendText(" Please go to step 3! " + NewLine + Return);
				
				reader.Close();
				inStream.Close();

				checkit1 =1;
			}

			else checkit1 =0;
		}

		private void ApplyFuzzyCluster_Load(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox1_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox2_Enter(object sender, System.EventArgs e)
		{
		
		}
	}
}
