using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.IO;

namespace GeoXplore
{
	/// <summary>
	/// Summary description for RBFLNClassification.
	/// </summary>
	public class RBFLNClassification : System.Windows.Forms.Form
	{		
		int	checkit1;
		int checkit2;
		int checkit3;

		double SumError1,SumError2,SSE,MSE;
		
		public static string			inFile1,inFile2;			//names of input data files
		public static string			outFile;			//name of output data file

		char			NewLine		= (char)13;
		char			Return		= (char)10;
		
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.OpenFileDialog openFileDialog2;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public RBFLNClassification()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(RBFLNClassification));
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.button3 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.button4 = new System.Windows.Forms.Button();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.button6 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button1 = new System.Windows.Forms.Button();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.groupBox3.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox3
			// 
			this.groupBox3.BackColor = System.Drawing.Color.Transparent;
			this.groupBox3.Controls.Add(this.button3);
			this.groupBox3.Controls.Add(this.textBox1);
			this.groupBox3.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox3.Location = new System.Drawing.Point(24, 112);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(288, 64);
			this.groupBox3.TabIndex = 19;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Step 2: Input Training Result File !";
			this.groupBox3.Enter += new System.EventHandler(this.groupBox3_Enter);
			// 
			// button3
			// 
			this.button3.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button3.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button3.ForeColor = System.Drawing.Color.Black;
			this.button3.Location = new System.Drawing.Point(192, 24);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(80, 23);
			this.button3.TabIndex = 1;
			this.button3.Text = "Load File";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 24);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(160, 22);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			// 
			// textBox4
			// 
			this.textBox4.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.textBox4.Font = new System.Drawing.Font("Times New Roman", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox4.ForeColor = System.Drawing.SystemColors.WindowText;
			this.textBox4.Location = new System.Drawing.Point(344, 32);
			this.textBox4.Multiline = true;
			this.textBox4.Name = "textBox4";
			this.textBox4.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox4.Size = new System.Drawing.Size(408, 392);
			this.textBox4.TabIndex = 18;
			this.textBox4.Text = "";
			this.textBox4.TextChanged += new System.EventHandler(this.textBox4_TextChanged);
			// 
			// groupBox4
			// 
			this.groupBox4.BackColor = System.Drawing.Color.Transparent;
			this.groupBox4.Controls.Add(this.button4);
			this.groupBox4.Controls.Add(this.textBox3);
			this.groupBox4.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox4.ForeColor = System.Drawing.Color.SeaShell;
			this.groupBox4.Location = new System.Drawing.Point(24, 280);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(288, 64);
			this.groupBox4.TabIndex = 16;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Step 4: Select Path and Name for Output File !";
			// 
			// button4
			// 
			this.button4.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button4.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button4.ForeColor = System.Drawing.Color.SeaShell;
			this.button4.Location = new System.Drawing.Point(192, 24);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(80, 23);
			this.button4.TabIndex = 1;
			this.button4.Text = "Save As";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// textBox3
			// 
			this.textBox3.Location = new System.Drawing.Point(16, 24);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(160, 22);
			this.textBox3.TabIndex = 0;
			this.textBox3.Text = "";
			// 
			// groupBox2
			// 
			this.groupBox2.BackColor = System.Drawing.Color.Transparent;
			this.groupBox2.Controls.Add(this.button2);
			this.groupBox2.Controls.Add(this.textBox2);
			this.groupBox2.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox2.Location = new System.Drawing.Point(24, 192);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(288, 64);
			this.groupBox2.TabIndex = 15;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Step 3: Input Data File for Classification !";
			// 
			// button2
			// 
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button2.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.ForeColor = System.Drawing.Color.Black;
			this.button2.Location = new System.Drawing.Point(192, 24);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(80, 23);
			this.button2.TabIndex = 1;
			this.button2.Text = "Load File";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(16, 24);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(160, 22);
			this.textBox2.TabIndex = 0;
			this.textBox2.Text = "";
			this.textBox2.TextChanged += new System.EventHandler(this.textBox2_TextChanged);
			// 
			// groupBox5
			// 
			this.groupBox5.BackColor = System.Drawing.Color.Transparent;
			this.groupBox5.Controls.Add(this.button6);
			this.groupBox5.Controls.Add(this.button5);
			this.groupBox5.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox5.ForeColor = System.Drawing.Color.SeaShell;
			this.groupBox5.Location = new System.Drawing.Point(24, 360);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(288, 64);
			this.groupBox5.TabIndex = 17;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Step 5: Apply RBFLN !";
			// 
			// button6
			// 
			this.button6.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button6.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button6.ForeColor = System.Drawing.Color.SeaShell;
			this.button6.Location = new System.Drawing.Point(160, 24);
			this.button6.Name = "button6";
			this.button6.TabIndex = 1;
			this.button6.Text = "Return";
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// button5
			// 
			this.button5.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button5.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button5.ForeColor = System.Drawing.Color.SeaShell;
			this.button5.Location = new System.Drawing.Point(48, 24);
			this.button5.Name = "button5";
			this.button5.TabIndex = 0;
			this.button5.Text = "Run";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.BackColor = System.Drawing.Color.Transparent;
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Font = new System.Drawing.Font("Times New Roman", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox1.Location = new System.Drawing.Point(24, 24);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(288, 64);
			this.groupBox1.TabIndex = 14;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Step 1: Read Instruction Before Processing Data!";
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button1.Font = new System.Drawing.Font("Times New Roman", 9.75F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(96, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Instructions";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// RBFLNClassification
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(800, 476);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.textBox4);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox5);
			this.Controls.Add(this.groupBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "RBFLNClassification";
			this.Text = "RBFLN Classification";
			this.groupBox3.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void button6_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button3_Click(object sender, System.EventArgs e)
		{			
			textBox4.Clear();	
			
			openFileDialog1.Filter = "par Files (*.par)|*.par|All files (*.*)|*.*" ;
			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{						
				textBox1.Text = openFileDialog1.FileName;
				inFile1 = openFileDialog1.FileName;	
		
				this.textBox4.AppendText(" Training data file has been read successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText("" + textBox1.Text + NewLine + Return+NewLine + Return);
				this.textBox4.AppendText(" Please go to Step 3 ! ");
			}			
			
		}

		private void button2_Click(object sender, System.EventArgs e)
		{			
			textBox4.Clear();	
			
			openFileDialog2.Filter = "dta Files (*.dta)|*.dta|All files (*.*)|*.*" ;

			if(openFileDialog2.ShowDialog() == DialogResult.OK)
			{						
				textBox2.Text = openFileDialog2.FileName;
				inFile2 = openFileDialog2.FileName;	
				this.textBox4.AppendText(" Data file has been read successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText("" + textBox2.Text + NewLine + Return+NewLine + Return);
				this.textBox4.AppendText(" Please go to step 4! " + NewLine + Return);
			}			
			
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			textBox4.Clear();
			saveFileDialog1.Filter = "rbn Files (*.rbn)|*.rbn|All files (*.*)|*.*" ;	
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				textBox3.Text = saveFileDialog1.FileName;
				outFile = saveFileDialog1.FileName;		
				this.textBox4.AppendText("The Result of the Radial Basis Function Link Network for each vector will be saved in the following file : "+ NewLine+Return + NewLine + Return);
				this.textBox4.AppendText(""+ textBox3.Text + NewLine + Return+NewLine + Return);
				this.textBox4.AppendText("Please click Run button! "+ NewLine+Return);

				checkit3 =1;


			}

			else checkit3=0;

			
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			int r;
			double MinGoodness = 9999.99;
			
			double MaxGoodness = 0;
			
			textBox4.Clear();	
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);	
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);
			this.textBox4.AppendText(" "+NewLine + Return);	
			
			checkit1 = RbflnFunctions.readtrainingresults();
	
			checkit2 = RbflnFunctions.readfile2();			
			
			if ((checkit1 ==1)&&(checkit2 ==1)&&(checkit3==1))
			{
				textBox4.Clear();
				this.textBox4.AppendText(" The program is running, please wait..." + NewLine + Return);
				
				//---------------------------save the result to the output file----------------------			
				// get name of selected output file
				
				FileStream outStream = new FileStream(outFile,FileMode.OpenOrCreate);

				// define writer to write stream to output file
				//StreamWriter writer = new StreamWriter(outStream,Encoding.ASCII);
				StreamWriter writer = new StreamWriter(outStream);
				outStream.Seek(0,SeekOrigin.Begin);				
				
				RbflnFunctions.execute();	
		
				textBox4.Clear();
				
				this.textBox4.AppendText(" The classification is done successfully ! " + NewLine + Return+ NewLine + Return );
				this.textBox4.AppendText(" Please go to " + textBox3.Text + " to check out the classification results" + NewLine + Return);
				
				this.textBox4.AppendText(" -----------------------------------------------------------"+NewLine + Return);
				this.textBox4.AppendText(" RBFLN Classification Overall-Measures: " + NewLine + Return + NewLine + Return);
								
				
				SumError1=0;
				SumError2 = 0;
				SSE =0;

				for (r=0;r<RbflnFunctions.R;r++)
				{
				
					if (RbflnFunctions.ClassificationBelief[r]< MinGoodness)
					{
						MinGoodness = RbflnFunctions.ClassificationBelief[r];
					
					}				
				
				}
				
				for (r=0;r<RbflnFunctions.R;r++)
				 {
				
					 if (RbflnFunctions.ClassificationBelief[r]> MaxGoodness)
					 {
						 MaxGoodness = RbflnFunctions.ClassificationBelief[r];
					
					 }				
				
				 }

				for (r=0;r<RbflnFunctions.R;r++)
				{
					if ( RbflnFunctions.ClassificationBelief[r]>0.5)
					{
						SumError1 = SumError1 + Math.Pow((RbflnFunctions.ClassificationBelief[r] - 1),2); 
					}

					else 
					{
						SumError2 = SumError2 + Math.Pow((RbflnFunctions.ClassificationBelief[r]),2); 
					}
				
				}
				
				SSE = SumError1 + SumError2;
				MSE = (SumError1 + SumError2)/RbflnFunctions.R;

				
				this.textBox4.AppendText(" Minimum Classification Error : " + Convert.ToString(String.Format("{0:0.0000}" , MinGoodness)) + NewLine + Return);			
				this.textBox4.AppendText(" Maximum Classification Error : " + Convert.ToString(String.Format("{0:0.0000}" , MaxGoodness)) + NewLine + Return);
				this.textBox4.AppendText(" MSE = " + Convert.ToString(String.Format("{0:0.0000}" , MSE)) + NewLine + Return);
				this.textBox4.AppendText(" SSE = " + Convert.ToString(String.Format("{0:0.0000}" , SSE)) + NewLine + Return + NewLine + Return);

				this.textBox4.AppendText("The classification result is being written to the file, please wait..." + NewLine + Return);
								
				//----Write Testing Results Data to File----------------------
				for ( r=0;r<RbflnFunctions.R;r++)
				{					
					writer.Write("" + Convert.ToString(r+1));						
					
					writer.Write(","+ Convert.ToString(1));					
					
					writer.Write("," + Convert.ToString(String.Format("{0:0.0000}" , RbflnFunctions.ClassificationBelief[r]))+ "   ");
					writer.Write("" + NewLine + Return);

				}
							
				writer.Flush(); 

				// close output stream
				writer.Close();
				outStream.Close();	
		
				//RbflnFunctions.GarbargCollect();
			
				RbflnClassificationResult dlg = new RbflnClassificationResult();
				dlg.ShowDialog();


			}

			else 
			{
			
				MessageBox.Show(" Please input valid files before running !" );
			}

		}

		private void groupBox3_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			RbflnClassificationInstruction dlg = new RbflnClassificationInstruction();
			dlg.ShowDialog();
		}

		private void textBox4_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void textBox2_TextChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
